//+------------------------------------------------------------------+
//|                                                   ma crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Purple

//
//
//
//
//

extern int    ADXbars          = 14;
extern bool   regchannel       = false;
extern int    STD.Rgres.period = 0;
extern int    STD.Rgres.length = 56;
extern double STD.Rgres.width  = 1.618;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundfile        = "alert2.wav";

extern int    arrowthickness   = 2;


//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowthickness); SetIndexArrow(0,108);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowthickness); SetIndexArrow(1,108);
   SetIndexBuffer(2, trend);
   return(0);
}
int deinit() 
{  
   ObjectsDeleteAll(0,OBJ_STDDEVCHANNEL); 
   ObjectsDeleteAll(0,OBJ_TRENDBYANGLE); 
   ObjectsDeleteAll(0,OBJ_TREND);
   Comment("");
   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {
	   double plusdi  = iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI,i);
  	   double minusdi = iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,i);
      
      trend[i] = trend[i+1];
         if (plusdi>minusdi) trend[i] = 1;
         if (plusdi<minusdi) trend[i] =-1;

         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
         }
         
         //
         //
         //
         //
         //
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
               int whichBar = 0;
           else     whichBar = 1;
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
         }
         
         //
         //
         //
         //
         //
         
         if (regchannel==TRUE)
         {
           double starttime = iTime(Symbol(),STD.Rgres.period,STD.Rgres.length);
              ObjectCreate("regression channel",OBJ_STDDEVCHANNEL,0,starttime,Bid,Time[0],Ask);
                 ObjectSet("regression channel",OBJPROP_TIME1,starttime);
                 ObjectSet("regression channel",OBJPROP_TIME2,Time[0]);
                 ObjectSet("regression channel",OBJPROP_DEVIATION,STD.Rgres.width);
                 ObjectSet("regression channel",OBJPROP_RAY,true);
           double one = ObjectGet("regression channel", OBJPROP_PRICE1);
           double two = ObjectGet("regression channel", OBJPROP_PRICE2);
           double rtrend;
           double grad,b;
           if (one<two) { rtrend = 1;  b = two-one; }
           if (one>two) { rtrend =-1;  b = one-two; }

               ObjectCreate("grad channel",OBJ_TRENDBYANGLE,0,0,0);
                  ObjectSet("grad channel",OBJPROP_WIDTH,3);
                  ObjectSet("grad channel",OBJPROP_TIME1,starttime);
                  ObjectSet("grad channel",OBJPROP_TIME2,Time[0]);
                  ObjectSet("grad channel",OBJPROP_PRICE1,one);
                  ObjectSet("grad channel",OBJPROP_PRICE2,two); 
           grad = ObjectGet("grad channel", OBJPROP_ANGLE);
      
           double hi = iHigh(NULL,PERIOD_D1,1);
           double lo =  iLow(NULL,PERIOD_D1,1);
             ObjectCreate("HDayBorder", OBJ_TREND, 0, 0,0, 0,0);
                ObjectSet("HDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STD.Rgres.length], TIME_DATE)+" 00:00"));
                ObjectSet("HDayBorder", OBJPROP_TIME2, Time[0]);
                ObjectSet("HDayBorder", OBJPROP_PRICE1, hi);
                ObjectSet("HDayBorder", OBJPROP_PRICE2, hi);
                ObjectSet("HDayBorder", OBJPROP_COLOR, Blue);
                ObjectSet("HDayBorder", OBJPROP_STYLE, STYLE_DASH);
        
             ObjectCreate("LDayBorder", OBJ_TREND, 0, 0,0, 0,0);
                ObjectSet("LDayBorder", OBJPROP_TIME1, StrToTime(TimeToStr(Time[STD.Rgres.length], TIME_DATE)+" 00:00"));
                ObjectSet("LDayBorder", OBJPROP_TIME2, Time[0]);
                ObjectSet("LDayBorder", OBJPROP_PRICE1, lo);
                ObjectSet("LDayBorder", OBJPROP_PRICE2, lo);
                ObjectSet("LDayBorder", OBJPROP_COLOR, Red);
                ObjectSet("LDayBorder", OBJPROP_STYLE, STYLE_DASH);
}   
return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," adx cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," adx cross " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," adx cross "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

